import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./Accordion.css";
import * as React from "react";
import { Button } from '../../Button';
import { Icon } from '../../Icon';
import { Tooltip } from '../../TooltipEx';
import { css } from '../../Util';
var Accordion = /** @class */ (function (_super) {
    tslib_1.__extends(Accordion, _super);
    function Accordion(props) {
        var _this = _super.call(this, props) || this;
        var expandedDictionary = {};
        if (_this.props.initiallyExpandedGroups) {
            for (var _i = 0, _a = props.items; _i < _a.length; _i++) {
                var i = _a[_i];
                expandedDictionary[i.key] = false;
            }
            for (var _b = 0, _c = _this.props.initiallyExpandedGroups; _b < _c.length; _b++) {
                var i = _c[_b];
                expandedDictionary[i] = true;
            }
        }
        else {
            for (var _d = 0, _e = props.items; _d < _e.length; _d++) {
                var i = _e[_d];
                expandedDictionary[i.key] = props.initiallyExpandAll === true;
            }
        }
        _this.state = {
            expandedDictionary: expandedDictionary
        };
        return _this;
    }
    Accordion.prototype.expand = function (itemKey) {
        var expandedDictionary = this.state.expandedDictionary;
        if (!expandedDictionary[itemKey]) {
            this.toggleExpand(itemKey);
        }
    };
    Accordion.prototype.collapse = function (itemKey) {
        var expandedDictionary = this.state.expandedDictionary;
        if (expandedDictionary[itemKey]) {
            this.toggleExpand(itemKey);
        }
    };
    Accordion.prototype.render = function () {
        return (React.createElement("div", { className: css("accordion-root", this.props.className), role: "tablist" }, this.renderItems()));
    };
    Accordion.prototype.renderItems = function () {
        var items = this.props.items;
        var elements = [];
        for (var i = 0; i < items.length; i++) {
            elements.push(this.renderItem(items[i], i));
        }
        return elements;
    };
    Accordion.prototype.renderItem = function (item, index) {
        var expandedDictionary = this.state.expandedDictionary;
        return (React.createElement("div", { className: "accordion-item", key: item.key },
            React.createElement(Button, { subtle: true, onClick: this.toggleExpand.bind(this, item.key), className: "accordion-header", ariaExpanded: expandedDictionary[item.key], ariaSetSize: this.props.items.length, ariaPosInSet: index + 1 },
                React.createElement(Icon, { iconName: expandedDictionary[item.key] ? "ChevronDown" : "ChevronRight", className: "accordion-chevron" }),
                React.createElement(Tooltip, { overflowOnly: true },
                    React.createElement("div", { className: "text-ellipsis" }, item.title || item.key))),
            React.createElement("div", { className: css("accordion-content", !expandedDictionary[item.key] && "hidden") }, item.onRenderContent())));
    };
    Accordion.prototype.toggleExpand = function (key) {
        var expandedDictionary = this.state.expandedDictionary;
        expandedDictionary[key] = !expandedDictionary[key];
        if (this.props.onItemChanged) {
            this.props.onItemChanged(key, expandedDictionary[key]);
        }
        this.forceUpdate();
    };
    return Accordion;
}(React.Component));
export { Accordion };
