import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./Button.css";
import "./DropdownButton.css";
import * as React from "react";
import { Button } from "./Button";
import { Icon } from '../../Icon';
import { Location } from '../../Utilities/Position';
import { css, KeyCode } from '../../Util';
var buttonId = 1;
var DropdownButton = /** @class */ (function (_super) {
    tslib_1.__extends(DropdownButton, _super);
    function DropdownButton(props) {
        var _this = _super.call(this, props) || this;
        _this.containerElement = React.createRef();
        _this.buttonElement = React.createRef();
        _this.collapse = function () {
            if (_this.state.expanded) {
                _this.setState({ expanded: false });
            }
        };
        _this.expand = function () {
            if (!_this.state.expanded) {
                _this.setState({ expanded: true });
            }
        };
        _this.renderCallout = function () {
            return _this.props.renderDropdown(_this, _this.state.dropdownId, _this.props.anchorElement
                ? _this.props.anchorElement
                : !_this.props.anchorPoint
                    ? _this.containerElement.current
                        ? _this.containerElement.current
                        : undefined
                    : undefined, _this.props.anchorOffset || { horizontal: 0, vertical: 0 }, _this.props.anchorOrigin || { horizontal: Location.end, vertical: Location.end }, _this.props.anchorPoint, _this.props.dropdownOrigin || { horizontal: Location.end, vertical: Location.start });
        };
        _this.onClick = function (event) {
            if (!event.defaultPrevented && !_this.ignoreClick) {
                _this.expand();
                event.preventDefault();
            }
        };
        _this.onKeyDown = function (event) {
            if (!event.defaultPrevented) {
                if (!_this.props.disabled) {
                    if (!_this.props.ignoreArrowDown && event.which === KeyCode.downArrow) {
                        _this.ignoreClick = false;
                        _this.expand();
                        event.preventDefault();
                    }
                    else if (event.which === KeyCode.escape) {
                        _this.collapse();
                        event.preventDefault();
                    }
                }
            }
        };
        _this.onMouseDown = function () {
            // If the dropwdown is expanded when we click on it, we want to ignore the click
            // and let the blur occur and close the dropdown.
            _this.ignoreClick = _this.state.expanded;
        };
        _this.state = {
            dropdownId: _this.props.dropdownId || "dropdown-" + buttonId++,
            expanded: false,
            id: _this.props.id || "dropdown-button-" + buttonId++
        };
        return _this;
    }
    DropdownButton.prototype.render = function () {
        // We disable the tooltip when we are expanded. Make sure we dont remove it
        // from the component tree, this causes the button element to get regenerated
        // and focus wont return.
        return (React.createElement("div", { className: "bolt-dropdown-button", onKeyDown: this.onKeyDown, onMouseDown: this.onMouseDown, ref: this.containerElement },
            React.createElement(Button, tslib_1.__assign({}, this.props, { ariaControls: this.state.expanded ? this.state.dropdownId : undefined, ariaExpanded: this.state.expanded, ariaHasPopup: true, className: css(this.props.className, !this.props.text && !this.props.children && this.props.iconProps && "icon-only", this.state.expanded && "active"), onClick: this.onClick, ref: this.buttonElement, tooltipProps: this.props.tooltipProps ? Object.assign({}, this.props.tooltipProps, { disabled: this.state.expanded }) : undefined }),
                this.props.children,
                !this.props.hideDropdownIcon ? Icon({ key: "dropdown-icon", className: "icon-right", iconName: "ChevronDown" }) : undefined),
            this.state.expanded && this.containerElement.current && this.renderCallout()));
    };
    DropdownButton.prototype.focus = function () {
        if (this.buttonElement.current) {
            this.buttonElement.current.focus();
        }
    };
    return DropdownButton;
}(React.Component));
export { DropdownButton };
