import { IObservableArray } from '../../Core/Observable';
import { TitleSize } from '../../Header';
import { IHeaderCommandBarItem } from '../../HeaderCommandBar';
export interface ICardProps extends ICustomCardProps {
    /**
     * Props to forward to the content of the Card
     */
    contentProps?: ICardContentProps;

    /**
     * Optional commands to render in the Card's header
     */
    headerCommandBarItems?: IHeaderCommandBarItem[];

    /**
     * Props to forward to the header of the Card
     */
    titleProps?: ICardTitleProps;
}

export interface ICardContentProps {
    /**
     * An optional className to pass to the card content
     */
    className?: string;

    /**
     * Indicates the consumer does not want any horizontal padding.
     *
     * @default true
     */
    contentPadding?: boolean;
}

export interface ICardFooterProps {
    /**
     * An optional className to pass to the card footer
     */
    className?: string;
}

export interface ICardTitleProps {
    /**
     * An optional aria level to the title
     */
    ariaLevel?: number;

    /**
     * An optional className to pass to the title
     */
    className?: string;

    /**
     * Optional size to render the card's title
     */
    size?: TitleSize;

    /**
     * Optional title to display for the card
     */
    text?: string;
}

export interface ICustomCardProps {
    /**
     * An optional className to pass to the card container element
     */
    className?: string;
}