import * as tslib_1 from "tslib";
import "../../FabricInit";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./DateTimePicker.css";
import * as React from "react";
import { DatePicker } from "office-ui-fabric-react/lib/DatePicker";
import { TextFieldWithMessage } from '../../TextField';
import { warn } from "office-ui-fabric-react/lib/Utilities";
import * as Resources from '../../VSS.Resources.VSSUI';
import "./DateTimePicker.css";
var DateTimePicker = /** @class */ (function (_super) {
    tslib_1.__extends(DateTimePicker, _super);
    function DateTimePicker(props) {
        var _this = _super.call(this, props) || this;
        _this._value = new Date();
        _this.onAdditionalInfoChange = function (event, newValue) {
            var _a = _this.props.parseTimeFromString, parseTimeFromString = _a === void 0 ? _this._defaultParseTimeFromString : _a;
            _this.setState({
                dateValue: newValue,
                dateErrorMessage: _this._getErrorMessage(newValue)
            });
            var parsedTime = parseTimeFromString(newValue);
            if (!!parsedTime) {
                _this._value.setHours(parsedTime.getHours(), parsedTime.getMinutes(), parsedTime.getSeconds());
                if (_this.props.onValueChanged) {
                    _this.props.onValueChanged(_this._value);
                }
            }
        };
        _this._getErrorMessage = function (value) {
            var _a = _this.props.parseTimeFromString, parseTimeFromString = _a === void 0 ? _this._defaultParseTimeFromString : _a;
            return !!parseTimeFromString(value) ? "" : Resources.DateTimePicker_CannotParseTime;
        };
        if (props) {
            if ("value" in props) {
                warn("'value' will be ignored. Use 'defaultValue'.");
            }
            if ("onSelectDate" in props) {
                warn("'onSelectDate' will be ignored.");
            }
            _this._value = props.defaultValue;
            _this.state = {
                dateValue: _this.props.formatTime ? _this.props.formatTime(_this._value) : _this._defaultFormatTime(_this._value),
                dateErrorMessage: ""
            };
        }
        return _this;
    }
    DateTimePicker.prototype.render = function () {
        var _this = this;
        var _a = this.state, dateValue = _a.dateValue, dateErrorMessage = _a.dateErrorMessage;
        if (this.props.dateOnly) {
            return React.createElement(DatePicker, tslib_1.__assign({ "aria-label": Resources.DateTimePicker_DateFieldAriaLabel }, this.props));
        }
        return (React.createElement("div", { className: "vss-DateTimePicker" },
            React.createElement("div", { className: "vss-DateTimePicker--dateField" },
                React.createElement(DatePicker, tslib_1.__assign({ className: this.props.dateFieldClassName, isMonthPickerVisible: false }, this.props, { value: this._value, ariaLabel: this.props.dateAriaLabel || Resources.DateTimePicker_DateFieldAriaLabel, maxDate: this.props.maxDate, minDate: this.props.minDate, onSelectDate: function (date) {
                        if (_this._value) {
                            _this._value.setFullYear(date.getFullYear(), date.getMonth(), date.getDate());
                        }
                        if (_this.props.onValueChanged) {
                            _this.props.onValueChanged(_this._value);
                        }
                    } }))),
            React.createElement("div", { className: "vss-DateTimePicker--timeField" },
                React.createElement(TextFieldWithMessage, { className: this.props.timeFieldClassName, textFieldProps: {
                        value: dateValue,
                        onChange: this.onAdditionalInfoChange,
                        ariaLabel: this.props.timeAriaLabel || Resources.DateTimePicker_TimeFieldAriaLabel
                    }, message: dateErrorMessage, error: dateErrorMessage !== "" }))));
    };
    DateTimePicker.prototype._defaultParseTimeFromString = function (timeStr) {
        var date = Date.parse(timeStr);
        if (date) {
            return new Date(date);
        }
        return null;
    };
    DateTimePicker.prototype._defaultFormatTime = function (date) {
        if (date) {
            return date.toLocaleTimeString();
        }
        return "";
    };
    return DateTimePicker;
}(React.Component));
export { DateTimePicker };
