import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./DateTimeRangePicker.css";
import * as React from "react";
import * as Resources from '../../VSS.Resources.VSSUI';
import { DateTimePicker } from "../../DateTimePicker";
import "./DateTimeRangePicker.css";
function min(a, b) {
    if (!a) {
        return b;
    }
    if (!b) {
        return a;
    }
    return a < b ? a : b;
}
function max(a, b) {
    if (!a) {
        return b;
    }
    if (!b) {
        return a;
    }
    return a > b ? a : b;
}
var DateTimeRangePicker = /** @class */ (function (_super) {
    tslib_1.__extends(DateTimeRangePicker, _super);
    function DateTimeRangePicker(props) {
        var _this = _super.call(this, props) || this;
        if (props) {
            _this._startTime = props.defaultStartTime;
            _this._endTime = props.defaultEndTime;
        }
        return _this;
    }
    DateTimeRangePicker.prototype.render = function () {
        var _this = this;
        var _a = this.props, maxDate = _a.maxDate, minDate = _a.minDate;
        return (React.createElement("div", { className: "vss-DateTimeRangePicker" },
            React.createElement("div", { className: "vss-DateTimeRangePicker--container" },
                React.createElement("span", { className: "vss-DateTimeRangePicker--label" }, Resources.DateTimeRangePicker_Start),
                React.createElement(DateTimePicker, { dateFieldClassName: "startDate", timeFieldClassName: "startTime", defaultValue: this._startTime, maxDate: min(maxDate, this._endTime), minDate: minDate, disableAutoFocus: true, formatDate: this.props.formatDate, formatTime: this.props.formatTime, parseTimeFromString: this.props.parseTimeFromString, onValueChanged: function (date) {
                        _this._startTime = date;
                        if (_this.props.onValueChanged) {
                            _this.props.onValueChanged(_this._startTime, _this._endTime);
                        }
                    }, dateAriaLabel: this.props.startDateAriaLabel || Resources.DateTimeRangePicker_StartDate, timeAriaLabel: this.props.startTimeAriaLabel || Resources.DateTimeRangePicker_StartTime })),
            React.createElement("div", { className: "vss-DateTimeRangePicker--container" },
                React.createElement("span", { className: "vss-DateTimeRangePicker--label" }, Resources.DateTimeRangePicker_End),
                React.createElement(DateTimePicker, { dateFieldClassName: "endDate", timeFieldClassName: "endTime", defaultValue: this._endTime, maxDate: maxDate, minDate: max(minDate, this._startTime), disableAutoFocus: true, formatDate: this.props.formatDate, formatTime: this.props.formatTime, parseTimeFromString: this.props.parseTimeFromString, onValueChanged: function (date) {
                        _this._endTime = date;
                        if (_this.props.onValueChanged) {
                            _this.props.onValueChanged(_this._startTime, _this._endTime);
                        }
                    }, dateAriaLabel: this.props.endDateArialLabel || Resources.DateTimeRangePicker_EndDate, timeAriaLabel: this.props.endTimeAriaLabel || Resources.DateTimeRangePicker_EndTime }))));
    };
    return DateTimeRangePicker;
}(React.Component));
export { DateTimeRangePicker };
