import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./Dialog.css";
import * as React from "react";
import { Callout, ContentOrientation, ContentSize, ContentJustification, ContentLocation } from '../../Callout';
import { FocusZone, FocusZoneKeyStroke } from '../../FocusZone';
import { css, isArrowKey } from '../../Util';
var CustomDialog = /** @class */ (function (_super) {
    tslib_1.__extends(CustomDialog, _super);
    function CustomDialog() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CustomDialog.prototype.render = function () {
        var _a = this.props, ariaLabel = _a.ariaLabel, blurDismiss = _a.blurDismiss, calloutClassName = _a.calloutClassName, className = _a.className, calloutContentClassName = _a.calloutContentClassName, contentJustification = _a.contentJustification, contentLocation = _a.contentLocation, defaultActiveElement = _a.defaultActiveElement, escDismiss = _a.escDismiss, id = _a.id, lightDismiss = _a.lightDismiss, onDismiss = _a.onDismiss, modal = _a.modal, _b = _a.contentSize, contentSize = _b === void 0 ? ContentSize.Medium : _b;
        return (React.createElement(Callout, { ariaLabel: ariaLabel, blurDismiss: blurDismiss, className: css(calloutClassName, "bolt-dialog-callout"), contentClassName: css(calloutContentClassName, "bolt-dialog-callout-content relative scroll-auto"), contentJustification: contentJustification, contentLocation: contentLocation, contentOrientation: ContentOrientation.Column, contentShadow: true, contentSize: contentSize, id: id, escDismiss: escDismiss, lightDismiss: lightDismiss, modal: modal, onDismiss: onDismiss },
            React.createElement(FocusZone, { circularNavigation: true, defaultActiveElement: defaultActiveElement || ".bolt-dialog-focus-element", focusOnMount: true, handleTabKey: true, includeDefaults: true, preprocessKeyStroke: function (event) {
                    return isArrowKey(event) ? FocusZoneKeyStroke.IgnoreParents : FocusZoneKeyStroke.IgnoreNone;
                } },
                React.createElement("div", { className: css(className, "bolt-dialog-focus-element flex-column flex-grow scroll-hidden"), tabIndex: -1 }, this.props.children))));
    };
    CustomDialog.defaultProps = {
        contentJustification: ContentJustification.Center,
        contentLocation: ContentLocation.Center,
        escDismiss: true,
        lightDismiss: true
    };
    return CustomDialog;
}(React.Component));
export { CustomDialog };
