import { IListBoxItem, IListBoxProps } from '../../ListBox';
import { IListSelection } from '../../List';
export interface IDropdownProps<T> {
    /**
     * Adds aria-label to the DropdownButton element.
     */
    ariaLabel?: string;

    /**
     * Classname to pass to the DropdownButton.
     */
    className?: string;

    /**
     * Props describing how to render the listbox on the dropdown callout.
     */
    listBoxProps: IListBoxProps<T>;

    /**
     * Text to show within the DropdownButton when there is no selected value.
     */
    placeholder?: string;

    /**
     * Optional custom renderer for selected items.
     */
    renderSelectedItems?: (selection: IListSelection, items: IListBoxItem<T>[]) => JSX.Element | string;
}