import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./Dropdown.css";
import * as React from "react";
import { ObservableLike } from '../../Core/Observable';
import { DropdownButton } from '../../Button';
import { Callout } from '../../Callout';
import { FocusZoneDirection } from '../../FocusZone';
import { ListBox } from '../../Listbox';
import { Observer } from '../../Observer';
var Dropdown = /** @class */ (function (_super) {
    tslib_1.__extends(Dropdown, _super);
    function Dropdown() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.dropdownButton = React.createRef();
        _this.renderDropdown = function (dropdown, dropdownId, anchorElement, anchorOffset, anchorOrigin, anchorPoint, dropdownOrigin) {
            return (React.createElement(Callout, { anchorElement: anchorElement, anchorOffset: anchorOffset, anchorOrigin: anchorOrigin, anchorPoint: anchorPoint, blurDismiss: true, calloutOrigin: dropdownOrigin, contentClassName: "bolt-dropdown flex-column custom-scrollbar", contentShadow: true, id: dropdownId, onDismiss: dropdown.collapse },
                React.createElement(ListBox, tslib_1.__assign({ focuszoneProps: { focusOnMount: true, direction: FocusZoneDirection.Vertical } }, _this.props.listBoxProps))));
        };
        _this.onSelect = function () {
            var selection = _this.props.listBoxProps.selection;
            if (selection.value.length > 0 && !selection.multiSelect) {
                if (_this.dropdownButton.current) {
                    _this.dropdownButton.current.collapse();
                }
            }
            return true;
        };
        return _this;
    }
    Dropdown.prototype.render = function () {
        var _this = this;
        var selection = this.props.listBoxProps.selection;
        var items = ObservableLike.getValue(this.props.listBoxProps.items);
        var selectionObservable = { observableValue: selection, filter: this.onSelect };
        return (React.createElement(Observer, { selection: selectionObservable }, function () {
            var text = _this.props.placeholder;
            if (selection.selectedCount > 0) {
                if (_this.props.renderSelectedItems) {
                    text = _this.props.renderSelectedItems(selection, items);
                }
            }
            return (React.createElement(DropdownButton, { ariaLabel: _this.props.ariaLabel, className: _this.props.className, ref: _this.dropdownButton, renderDropdown: _this.renderDropdown }, text));
        }));
    };
    Dropdown.defaultProps = {
        renderSelectedItems: renderDropdownSelectedItemText
    };
    return Dropdown;
}(React.Component));
export { Dropdown };
export function renderDropdownSelectedItemText(selection, items) {
    var text = items[selection.value[0].beginIndex].text || "";
    if (selection.selectedCount > 1) {
        text = text + " (+" + (selection.selectedCount - 1) + ")";
    }
    return text;
}
