import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import * as React from "react";
import { FocusGroupContext } from '../../FocusGroup';
import { FocusZoneContext } from '../../FocusZone';
import { MouseWithin } from '../../MouseWithin';
import { css, getSafeId, KeyCode } from '../../Util';
import { getTabIndex } from '../../Utilities/Focus';
var expandableId = 1;
var Expandable = /** @class */ (function (_super) {
    tslib_1.__extends(Expandable, _super);
    function Expandable() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.expandedOnHover = false;
        _this.expandableId = "expandable-" + expandableId++;
        _this.element = React.createRef();
        _this.state = { expanded: false };
        _this.collapse = function () {
            if (_this.state.expanded) {
                _this.expandedOnHover = false;
                _this.setState({ expanded: false });
            }
        };
        _this.expand = function () {
            if (!_this.state.expanded) {
                _this.setState({ expanded: !_this.state.expanded });
            }
        };
        _this.onClick = function (event) {
            if (_this.element.current && _this.element.current.contains(event.target) && !event.defaultPrevented) {
                _this.expand();
                event.preventDefault();
            }
        };
        _this.onFocus = function () {
            if (_this.focusGroupContext && _this.props.id) {
                _this.focusGroupContext.onFocus(_this.props.id);
            }
        };
        _this.onKeyDown = function (event) {
            if (!event.defaultPrevented) {
                if ((Array.isArray(_this.props.expandKey) && _this.props.expandKey.indexOf(event.which)) || event.which === _this.props.expandKey) {
                    _this.expand();
                    event.preventDefault();
                }
            }
        };
        _this.onMouseEnter = function () {
            if (_this.props.expandOnHover && !_this.state.expanded) {
                _this.expandedOnHover = true;
                _this.expand();
            }
        };
        _this.onMouseLeave = function () {
            if (_this.expandedOnHover && _this.state.expanded) {
                _this.collapse();
            }
        };
        return _this;
    }
    Expandable.prototype.render = function () {
        var _this = this;
        return (React.createElement(FocusGroupContext.Consumer, null, function (focusGroupContext) {
            _this.focusGroupContext = focusGroupContext;
            return (React.createElement(FocusZoneContext.Consumer, null, function (zoneContext) { return (React.createElement(MouseWithin, { enterDelay: _this.props.expandDelay, leaveDelay: _this.props.collapseDelay, onMouseEnter: _this.onMouseEnter, onMouseLeave: _this.onMouseLeave, updateStateOnMouseChange: false }, function (mouseContext) {
                var expanded = _this.state.expanded;
                return (React.createElement("div", { "aria-expanded": expanded, "aria-haspopup": true, "aria-controls": expanded ? getSafeId(_this.props.expandableId) : undefined, className: css(_this.props.className, "bolt-expandable flex-row flex-center", expanded && "expanded"), "data-focuszone": !_this.props.disabled && !_this.props.excludeFocusZone ? zoneContext.focuszoneId : undefined, id: getSafeId(_this.props.id), onClick: _this.onClick, onFocus: _this.onFocus, onKeyDown: _this.onKeyDown, onMouseEnter: mouseContext.onMouseEnter, onMouseLeave: mouseContext.onMouseLeave, role: _this.props.role, tabIndex: getTabIndex(_this.props, focusGroupContext), ref: _this.element },
                    _this.props.children,
                    expanded &&
                        _this.element.current &&
                        _this.props.renderCallout(_this, _this.props.expandableId || _this.expandableId, _this.element.current)));
            })); }));
        }));
    };
    Expandable.defaultProps = {
        collapseDelay: 250,
        expandKey: KeyCode.downArrow,
        expandDelay: 250
    };
    return Expandable;
}(React.Component));
export { Expandable };
