import "../../FabricInit";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./InfoIcon.css";
import * as React from "react";
import { IOrigin } from '../../Utilities/Position';
import { IVssIconProps } from '../../VssIcon';
export interface IInfoIconProps extends React.HTMLAttributes<HTMLDivElement> {
    /** Positioning origin of the info icon against the callout (default horizontal.center, vertical.start) */
    iconOrigin?: IOrigin;
    /** Props for the icon */
    iconProps: IVssIconProps;
    /** Positioning origin of the callout against the info icon (default horizontal.center, vertical.end) */
    infoOrigin?: IOrigin;
    /** The text to display in the callout */
    infoText?: string;
    /** Optional render override for the callout */
    onRenderContent?: () => JSX.Element;
}
export interface IInfoIconState {
    /** Is the callout open */
    calloutOpened: boolean;
}
/**
 * Icon which shows a callout with extra information when hovered
 */
export declare class InfoIcon extends React.PureComponent<IInfoIconProps, IInfoIconState> {
    private _calloutTarget;
    constructor(props: IInfoIconProps);
    render(): JSX.Element;
    private _renderCalloutContent;
    private _onClick;
    private _onKeyDown;
    private _onDismiss;
}
