import * as tslib_1 from "tslib";
import "../../FabricInit";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./InfoIcon.css";
import * as React from "react";
import { Callout } from '../../Callout';
import { css, KeyCode } from '../../Util';
import { Location } from '../../Utilities/Position';
import { getNativeProps, divProperties } from "office-ui-fabric-react/lib/Utilities";
import { VssIcon } from '../../VssIcon';
/**
 * Icon which shows a callout with extra information when hovered
 */
var InfoIcon = /** @class */ (function (_super) {
    tslib_1.__extends(InfoIcon, _super);
    function InfoIcon(props) {
        var _this = _super.call(this, props) || this;
        _this._onClick = function () {
            _this.setState({ calloutOpened: true });
        };
        _this._onKeyDown = function (event) {
            if (event.keyCode === KeyCode.enter || event.keyCode === KeyCode.space) {
                _this.setState({ calloutOpened: true });
            }
        };
        _this._onDismiss = function () {
            _this.setState({ calloutOpened: false });
        };
        _this._calloutTarget = React.createRef();
        _this.state = {
            calloutOpened: false
        };
        return _this;
    }
    InfoIcon.prototype.render = function () {
        var _a = this.props, _b = _a.iconOrigin, iconOrigin = _b === void 0 ? { horizontal: Location.center, vertical: Location.start } : _b, iconProps = _a.iconProps, _c = _a.infoOrigin, infoOrigin = _c === void 0 ? { horizontal: Location.center, vertical: Location.end } : _c, infoText = _a.infoText;
        var calloutOpened = this.state.calloutOpened;
        return (React.createElement("div", tslib_1.__assign({ "aria-label": infoText }, getNativeProps(this.props, divProperties), { ref: this._calloutTarget, onBlur: this._onDismiss, onClick: this._onClick, onKeyDown: this._onKeyDown, role: "button", tabIndex: 0 }),
            React.createElement(VssIcon, tslib_1.__assign({}, iconProps, { className: css(iconProps.className, "vss-info-icon") })),
            calloutOpened && (React.createElement(Callout, { anchorElement: this._calloutTarget.current, anchorOrigin: iconOrigin, calloutOrigin: infoOrigin, contentClassName: "vss-info-callout", contentShadow: true, onDismiss: this._onDismiss }, this._renderCalloutContent()))));
    };
    InfoIcon.prototype._renderCalloutContent = function () {
        var _a = this.props, infoText = _a.infoText, onRenderContent = _a.onRenderContent;
        if (onRenderContent) {
            return onRenderContent();
        }
        else {
            return React.createElement("div", { className: "vss-info-text-container" }, infoText);
        }
    };
    return InfoIcon;
}(React.PureComponent));
export { InfoIcon };
