import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import * as React from "react";
import { IIntersectionProps } from "./Intersection.Props";
export interface IIntersectionContext {
    readonly rootMargin: number;
    readonly root: HTMLElement;
    observe: (element: HTMLElement) => void;
    register: (callback: IntersectionObserverCallback) => void;
    unobserve: (element: HTMLElement) => void;
    unregister: (callback: IntersectionObserverCallback) => void;
}
declare class IntersectionContextImpl implements IIntersectionContext {
    private callbacks;
    private observer?;
    private pending;
    rootMargin: number;
    root: HTMLElement;
    connect(root: HTMLElement, rootMargin?: number): void;
    disconnect(): void;
    observe(element: HTMLElement): void;
    register(callback: IntersectionObserverCallback): void;
    unobserve(element: HTMLElement): void;
    unregister(callback: IntersectionObserverCallback): void;
    private onIntersect;
}
export declare const IntersectionContext: React.Context<IIntersectionContext>;
export declare class Intersection extends React.Component<IIntersectionProps, IIntersectionContext> {
    state: IntersectionContextImpl;
    private rootElement;
    constructor(props: Readonly<IIntersectionProps>);
    render(): JSX.Element;
    componentDidMount(): void;
    componentWillUnmount(): void;
}
export {};
