import * as React from "react";
import { IItem } from "../../Components/ItemIndicator/Item";
import { IVssIconProps } from '../../VssIcon';
export interface IItemIndicatorProps {
    /**
     * The value to display for this item's indicator. Typically presented as a tooltip on the indicator.
     */
    title?: string;

    /*
     * Icon that represents the state of the indicator for the list item.
     */
    iconProps?: IVssIconProps;

    /**
     * An onClick handler indicates that the indicator is actionable.
     */
    onClick?: (ev?: React.MouseEvent<HTMLButtonElement | HTMLAnchorElement>, item?: IItem) => any;

    /**
     * Optional item to keep the state of the indicator.
     */
    item?: IItem;

    /**
     * Class name to place on the indicator root element
     */
    className?: string;

    /**
     * Optional function to render custom item indicator
     */
    onRender?: () => JSX.Element;
}

export interface IItemIndicatorSetProps {
    /**
     * Indicators to display in the set
     */
    indicators: IItemIndicatorProps[];

    /**
     * Handler for clicks in the indicator set that do not fall on an indicator that has an onClick handler.
     */
    onClick?: (ev: React.MouseEvent<HTMLElement>) => void;
}