import { ITooltipProps } from '../../TooltipEx';
export interface ILink {
    focus(): void;
}

export interface ILinkProps {
    /**
     * Optional aria described by for detailed information about the link
     */
    ariaDescribedBy?: string;

    /**
     * Optional aria label
     */
    ariaLabel?: string;

    /**
     * Optional expanded flag for accessibility
     */
    ariaExpanded?: boolean;

    /**
     * Optional hasPopup for accessibility
     */
    ariaHasPopup?: boolean;

    /**
     * Optional class name to render
     */
    className?: string;

    /**
     * Optional standin for data-is-focusable
     * @@OFFICE_FABRIC remove when we are done.
     */
    dataIsFocusable?: boolean;

    /**
     * Optional disabled boolean for the
     */
    disabled?: boolean;

    /**
     * Optional point to a download location
     */
    download?: string;

    /**
     * Set to true if you don't want the link's focus managed by a FocusZone.
     */
    excludeFocusZone?: boolean;

    /**
     * Set to true if you don't want the link's to be tabbable.
     */
    excludeTabStop?: boolean;

    /**
     * Optional href; if you don't provide one your link won't point anywhere
     */
    href?: string;

    /**
     * Optional ID to emit
     */
    id?: string;

    /**
     * Optional onBlur handler
     */
    onBlur?: (event: React.FocusEvent<HTMLAnchorElement>) => void;

    /**
     * Optional onClick handler
     */
    onClick?: (event: React.MouseEvent<HTMLAnchorElement> | React.KeyboardEvent<HTMLAnchorElement>) => void;

    /**
     * Optional onFocus handler
     */
    onFocus?: (event: React.FocusEvent<HTMLAnchorElement>) => void;

    /**
     * Optional hoverStart handler
     */
    onMouseEnter?: (event: React.MouseEvent<HTMLAnchorElement>) => void;

    /**
     * Optional hoverEnd handler
     */
    onMouseLeave?: (event: React.MouseEvent<HTMLAnchorElement>) => void;

    /**
     * Optional mouseOver handler
     */
    onMouseOver?: (event: React.MouseEvent<HTMLAnchorElement>) => void;

    /**
     * When a link opens in a new tab/window
     */
    rel?: string;

    /**
     * Optional role
     */
    role?: string;

    /**
     * Optional tabIndex
     */
    tabIndex?: number;

    /**
     * Optional target, eg. _blank
     */
    target?: string;

    /**
     * Optional link title
     */
    title?: string;

    /**
     * Optional tooltip to show when the link is hovered.
     */
    tooltipProps?: ITooltipProps;
}