import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./Link.css";
import * as React from "react";
import { FocusGroupContext } from '../../FocusGroup';
import { FocusZoneContext } from '../../FocusZone';
import { Tooltip } from '../../TooltipEx';
import { css, getSafeId } from '../../Util';
import { getTabIndex } from '../../Utilities/Focus';
var Link = /** @class */ (function (_super) {
    tslib_1.__extends(Link, _super);
    function Link() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ref = React.createRef();
        _this.onClick = function (event) {
            if (_this.props.disabled) {
                event.preventDefault();
            }
            else {
                _this.props.onClick && _this.props.onClick(event);
            }
        };
        _this.onFocus = function (event) {
            if (_this.props.onFocus) {
                _this.props.onFocus(event);
            }
            if (_this.focusGroupContext && _this.props.id) {
                _this.focusGroupContext.onFocus(_this.props.id);
            }
        };
        return _this;
    }
    Link.prototype.render = function () {
        var _this = this;
        return (React.createElement(FocusGroupContext.Consumer, null, function (focusGroupContext) {
            _this.focusGroupContext = focusGroupContext;
            return (React.createElement(FocusZoneContext.Consumer, null, function (focusZoneContext) {
                var props = tslib_1.__assign({}, _this.props);
                var ariaDescribedBy = props.ariaDescribedBy, ariaLabel = props.ariaLabel, ariaExpanded = props.ariaExpanded, ariaHasPopup = props.ariaHasPopup, className = props.className, excludeFocusZone = props.excludeFocusZone, target = props.target, dataIsFocusable = props.dataIsFocusable;
                var rel = props.rel, role = props.role;
                // If the link is targetting an external window or tab and no explicit rel
                // attribute was supplied we will set noopener.
                if (target && !rel) {
                    rel = "noopener";
                }
                if (!props.href && !props.role) {
                    role = "button";
                }
                var link = (React.createElement("a", { ref: _this.ref, "aria-describedby": getSafeId(ariaDescribedBy), "aria-expanded": ariaExpanded, "aria-haspopup": ariaHasPopup, "aria-label": ariaLabel, className: css(className, "bolt-link", props.disabled && "disabled"), "data-focuszone": !excludeFocusZone && focusZoneContext.focuszoneId, "data-is-focusable": dataIsFocusable, download: props.download, href: props.href, id: getSafeId(props.id), onBlur: props.onBlur, onClick: _this.onClick, onFocus: _this.onFocus, onMouseEnter: props.onMouseEnter, onMouseLeave: props.onMouseLeave, onMouseOver: props.onMouseOver, rel: rel, role: role, tabIndex: getTabIndex(_this.props, focusGroupContext), target: target }, _this.props.children));
                if (props.tooltipProps) {
                    link = React.createElement(Tooltip, tslib_1.__assign({}, props.tooltipProps), link);
                }
                return link;
            }));
        }));
    };
    Link.prototype.focus = function () {
        this.ref.current && this.ref.current.focus();
    };
    return Link;
}(React.Component));
export { Link };
