/**
 * Represents where within the containing element to draw the drop indicator
 */
export declare enum ListDropIndicatorPosition {
    bottom = 0,
    top = 1
}
export interface IListDropIndicatorProps {
    /**
     * Whether the indicator is appearing at the top, or the bottom of its containing element.
     * @default bottom
     */
    position?: ListDropIndicatorPosition;
    /**
     * How much to offset where the circle is rendered on the horizontal axis
     * @default 0
     */
    xOffset?: number;
}
