import { IButtonProps } from '../../Button';
import { IContextualMenuProps } from "./Menu.Props";

export interface IMenuButtonProps extends IButtonProps {
    /**
     * Properties for the menu that appears when the dropdown is shown.
     */
    contextualMenuProps: IContextualMenuProps;

    /**
     * If hideDropdownIcon is supplied the button acts as a dropdown button
     * without showing the dropdown arrows.
     */
    hideDropdownIcon?: boolean;

    /**
     * The ArrowDown key opens the dropdown by default, if ignoreArrowDown
     * is specified the arrow key will not open the dropdown. To open the
     * dropdown the button should be activated.
     */
    ignoreArrowDown?: boolean;
}