import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./Panel.css";
import * as React from "react";
import { Callout, ContentJustification, ContentLocation, ContentOrientation, ContentSize } from '../../Callout';
import { FocusZone, FocusZoneKeyStroke } from '../../FocusZone';
import { css, isArrowKey } from '../../Util';
var CustomPanel = /** @class */ (function (_super) {
    tslib_1.__extends(CustomPanel, _super);
    function CustomPanel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CustomPanel.prototype.render = function () {
        var props = this.props;
        var _a = props.size, size = _a === void 0 ? ContentSize.Medium : _a;
        return (React.createElement(Callout, { ariaLabel: props.ariaLabel, blurDismiss: props.blurDismiss, className: "bolt-panel", contentClassName: css(props.contentClassName, "bolt-panel-callout-content relative scroll-auto flex-grow"), contentJustification: ContentJustification.Stretch, contentLocation: ContentLocation.End, contentOrientation: ContentOrientation.Column, contentShadow: true, contentSize: size, id: props.id, escDismiss: props.escDismiss, lightDismiss: props.lightDismiss, modal: props.modal, onDismiss: props.onDismiss },
            React.createElement(FocusZone, { circularNavigation: true, defaultActiveElement: props.defaultActiveElement || ".bolt-panel-focus-element", focusOnMount: true, handleTabKey: true, includeDefaults: true, preprocessKeyStroke: function (event) {
                    return isArrowKey(event) ? FocusZoneKeyStroke.IgnoreParents : FocusZoneKeyStroke.IgnoreNone;
                } },
                React.createElement("div", { className: css(props.className, "bolt-panel-focus-element flex-column flex-grow scroll-hidden"), tabIndex: -1 }, props.children))));
    };
    CustomPanel.defaultProps = {
        escDismiss: true,
        lightDismiss: true,
        modal: true
    };
    return CustomPanel;
}(React.Component));
export { CustomPanel };
