import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./Panel.css";
import * as React from "react";
import { PanelCloseButtonSize } from "./Panel.Props";
import * as Resources from '../../Resources.Layer';
import { Header } from '../../Header';
import { css } from '../../Util';
export var PanelHeader = function (props) {
    var description = props.description, onDismiss = props.onDismiss, closeButtonSize = props.closeButtonSize, showCloseButton = props.showCloseButton, showSeparator = props.showSeparator, _a = props.titleProps, titleProps = _a === void 0 ? {} : _a;
    if (props.children) {
        return (React.createElement(React.Fragment, null,
            React.createElement("div", { className: css(props.className, "bolt-panel-header flex-noshrink flex-column scroll-hidden") }, props.children),
            showSeparator && React.createElement("div", { className: "bolt-panel-separator flex-noshrink" })));
    }
    var commandBarItems = [];
    if (showCloseButton !== false) {
        commandBarItems.push({
            id: "close-button",
            onActivate: onDismiss,
            ariaLabel: Resources.Close,
            iconProps: { iconName: closeButtonSize === PanelCloseButtonSize.small ? "Cancel" : "Clear" },
            subtle: true
        });
    }
    return (React.createElement(Header, { className: css(props.className, "bolt-panel-header"), description: description, separator: showSeparator, title: titleProps.text, titleClassName: titleProps.className, titleSize: titleProps.size, commandBarItems: commandBarItems }));
};
