import "../../FabricInit";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./PeoplePicker.css";
import "./Suggestions.css";
import * as React from "react";
import { Button } from '../../Button';
import { ISuggestionsProps } from "office-ui-fabric-react/lib/Pickers";
import { ISuggestionItemProps } from "./Suggestions.Props";
export declare enum SuggestionActionType {
    none = 0,
    forceResolve = 1,
    searchMore = 2
}
export interface ISuggestionsState {
    selectedActionType: SuggestionActionType;
}
export declare class SuggestionsItem<T> extends React.Component<ISuggestionItemProps<T>> {
    render(): JSX.Element;
}
export declare class Suggestions<T> extends React.Component<ISuggestionsProps<T>, ISuggestionsState> {
    protected _forceResolveButton: React.RefObject<Button>;
    protected _searchForMoreButton: React.RefObject<Button>;
    protected _selectedElement: React.RefObject<HTMLDivElement>;
    private SuggestionsItemOfProperType;
    private activeSelectedElement;
    constructor(suggestionsProps: ISuggestionsProps<T>);
    componentDidMount(): void;
    componentDidUpdate(): void;
    render(): JSX.Element;
    /**
     * Returns true if the event was handled, false otherwise
     */
    tryHandleKeyDown: (keyCode: number, currentSuggestionIndex: number) => boolean;
    hasSuggestedAction(): boolean;
    hasSuggestedActionSelected(): boolean;
    executeSelectedAction(): void;
    focusAboveSuggestions(): void;
    focusBelowSuggestions(): void;
    focusSearchForMoreButton(): void;
    scrollSelected(): void;
    private _renderSuggestions;
    private _getMoreResults;
    private _forceResolve;
    private _shouldShowForceResolve;
    private _onClickTypedSuggestionsItem;
    private _refocusOnSuggestions;
    private _onRemoveTypedSuggestionsItem;
}
