import * as tslib_1 from "tslib";
import "../../FabricInit";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./PeoplePickerDropdown.css";
import * as React from "react";
import { Suggestions } from "../PeoplePicker/Suggestions";
import { VssPersona } from '../../VssPersona';
import { css, KeyCode } from '../../Util';
import { getSignInAddress, isUser } from "../PeoplePicker/PeoplePickerUtils";
import { PersonaCard } from "../PersonaCard";
import { TimerManagement } from '../../Core/TimerManagement';
import * as Resources from '../../VSS.Resources.VSSUI';
import { TextField } from '../../TextField';
import { Button } from '../../Button';
import { Observer } from '../../Observer';
import { VssIcon } from '../../VssIcon';
import { ObservableValue } from '../../Core/Observable';
//TODO: Remove this in a future breaking change.
import { Callout } from "office-ui-fabric-react/lib/Callout";
import { SuggestionsController } from "office-ui-fabric-react/lib/Pickers";
var PeoplePickerDropdown = /** @class */ (function (_super) {
    tslib_1.__extends(PeoplePickerDropdown, _super);
    function PeoplePickerDropdown(props) {
        var _this = _super.call(this, props) || this;
        _this.areSuggestionsVisible = new ObservableValue(false);
        _this.hasFocus = new ObservableValue(false);
        _this.inputElement = React.createRef();
        _this.openedIdentityCard = new ObservableValue(undefined);
        _this.outerElement = React.createRef();
        _this.selectedIdentity = new ObservableValue(undefined);
        _this.suggestionsControl = React.createRef();
        _this.suggestionsLoading = new ObservableValue(false);
        _this.textValue = new ObservableValue("");
        _this.currentSuggestion = function () {
            return _this.selectedIdentity.value;
        };
        _this.hidePicker = function () {
            _this.areSuggestionsVisible.value = false;
            if (!_this.hasFocus.value) {
                _this.props.onBlur && _this.props.onBlur();
            }
        };
        _this.showPicker = function () {
            _this.areSuggestionsVisible.value = true;
        };
        _this.renderPersonaCoin = function (className) {
            var iconClassName = "bolt-peoplepickerdropdown-icon flex-row flex-center justify-center";
            return (React.createElement(Observer, { selectedIdentity: _this.selectedIdentity }, function (props) {
                return props.selectedIdentity ? (React.createElement(VssPersona, { className: iconClassName, displayName: props.selectedIdentity.displayName, imageUrl: props.selectedIdentity.image, size: "small" })) : (React.createElement(VssIcon, { className: iconClassName, iconName: "Contact" }));
            }));
        };
        _this.closePersonaCard = function () {
            _this.openedIdentityCard.value = undefined;
        };
        _this.completeSuggestion = function () {
            if (_this.suggestionStore.suggestions.length > 0 && _this.areSuggestionsVisible.value) {
                if (_this.suggestionStore.currentIndex < 0) {
                    _this.suggestionStore.nextSuggestion();
                }
                _this.setInputToSelectedPerson();
                _this.suggestionStore.currentSuggestion && _this.selectedPersonaChanged(_this.suggestionStore.currentSuggestion.item);
                _this.areSuggestionsVisible.value = false;
            }
            else {
                _this.suggestionStore.deselectAllSuggestions();
                _this.suggestionStore.currentSuggestion = undefined;
                _this.selectedPersonaChanged();
            }
        };
        _this.onBlur = function () {
            _this.hasFocus.value = false;
            _this.timerManagement.setTimeout(function () {
                var areContactOrSuggestionsOpen = !_this.openedIdentityCard.value && !_this.areSuggestionsVisible.value && !_this.areSuggestionsVisible.value;
                areContactOrSuggestionsOpen && _this.props.onBlur && _this.props.onBlur();
                areContactOrSuggestionsOpen && _this.selectedPersonaChanged(_this.selectedIdentity.value);
            }, 100);
        };
        _this.onClick = function () {
            if (_this.textValue.value === "" && _this.props.pickerProvider.onEmptyInputFocus) {
                _this.updateSuggestionsList(_this.props.pickerProvider.onEmptyInputFocus());
                _this.areSuggestionsVisible.value = !_this.areSuggestionsVisible.value;
            }
            else {
                _this.areSuggestionsVisible.value = !_this.areSuggestionsVisible.value;
            }
            _this.inputElement.current.select();
        };
        _this.onFocus = function (e) {
            var onFocus = _this.props.onFocus;
            if (_this.textValue.value === "" && _this.props.pickerProvider.onEmptyInputFocus && !_this.areSuggestionsVisible.value) {
                _this.updateSuggestionsList(_this.props.pickerProvider.onEmptyInputFocus());
            }
            _this.hasFocus.value = true;
            if (onFocus) {
                onFocus(e);
            }
        };
        _this.onKeyDown = function (ev) {
            var keyCode = ev.which;
            switch (keyCode) {
                case KeyCode.escape:
                    if (_this.openedIdentityCard.value) {
                        !_this.suggestionStore.currentSuggestion && _this.selectedPersonaChanged();
                    }
                    if (_this.areSuggestionsVisible.value) {
                        _this.areSuggestionsVisible.value = false;
                        _this.openedIdentityCard.value = undefined;
                    }
                    break;
                case KeyCode.tab:
                case KeyCode.enter:
                    if (_this.suggestionsControl.current && _this.suggestionsControl.current.hasSuggestedActionSelected()) {
                        _this.suggestionsControl.current.executeSelectedAction();
                        _this.completeSuggestion();
                    }
                    else if (!ev.shiftKey && _this.suggestionStore.hasSelectedSuggestion() && _this.areSuggestionsVisible.value) {
                        _this.completeSuggestion();
                        ev.preventDefault();
                        ev.stopPropagation();
                    }
                    else if (_this.areSuggestionsVisible.value) {
                        _this.completeSuggestion();
                    }
                    else {
                        _this.selectedPersonaChanged(_this.selectedIdentity.value);
                    }
                    break;
                case KeyCode.rightArrow:
                    if (_this.suggestionStore.currentSuggestion) {
                        _this.openedIdentityCard.value = _this.suggestionStore.currentSuggestion.item;
                    }
                    break;
                case KeyCode.upArrow:
                    if (_this.suggestionsControl.current && _this.suggestionsControl.current.tryHandleKeyDown(keyCode, _this.suggestionStore.currentIndex)) {
                        ev.preventDefault();
                        ev.stopPropagation();
                    }
                    else {
                        if (_this.suggestionsControl.current && _this.areSuggestionsVisible.value) {
                            _this.suggestionStore.previousSuggestion();
                            _this.forceUpdate();
                            ev.preventDefault();
                            ev.stopPropagation();
                        }
                    }
                    break;
                case KeyCode.downArrow:
                    if (_this.suggestionsControl.current && _this.suggestionsControl.current.tryHandleKeyDown(keyCode, _this.suggestionStore.currentIndex)) {
                        ev.preventDefault();
                        ev.stopPropagation();
                    }
                    else {
                        if (_this.suggestionsControl.current && _this.areSuggestionsVisible.value) {
                            _this.suggestionStore.nextSuggestion();
                            _this.forceUpdate();
                            ev.preventDefault();
                            ev.stopPropagation();
                        }
                        else {
                            _this.areSuggestionsVisible.value = true;
                        }
                    }
                    break;
            }
        };
        _this.onResolveSuggestions = function (updatedValue) {
            var suggestions = _this.props.pickerProvider.onFilterIdentities(updatedValue, [
                _this.suggestionStore.currentSuggestion && _this.suggestionStore.currentSuggestion.item
            ]);
            if (suggestions !== null) {
                _this.updateSuggestionsList(suggestions, updatedValue);
            }
        };
        _this.onSearchChange = function (event, value) {
            _this.areSuggestionsVisible.value = !!value;
            if (value.length == 0) {
                var onClear = _this.props.onClear;
                onClear && onClear();
            }
            _this.selectedIdentity.value = undefined;
            _this.textValue.value = value;
            _this.updateValue(value);
        };
        _this.onSuggestionClick = function (ev, item, index) {
            _this.suggestionStore.setSelectedSuggestion(index);
            _this.selectedPersonaChanged(item);
            _this.textValue.value = item.displayName;
            _this.hidePicker();
            ev.stopPropagation();
        };
        _this.renderNoIdentitiesFound = function () {
            return React.createElement("div", { className: "bolt-peoplepickerdropdown-noresults flex-row flex-center" }, Resources.PeoplePickerNoResultsText);
        };
        _this.renderSuggestionItem = function (props, itemProps) {
            var signInAddress = getSignInAddress(props);
            return (React.createElement("div", { className: "bolt-picker-suggesteditem flex-row flex-grow flex-center text-ellipsis" },
                React.createElement(VssPersona, { cssClass: "bolt-picker-persona text-ellipsis", identityDetailsProvider: {
                        getIdentityImageUrl: function (size) {
                            return props.image;
                        },
                        getDisplayName: function () {
                            return props.displayName;
                        }
                    }, size: "small" }),
                React.createElement("div", { className: "bolt-picker-persona-name flex-column flex-grow" },
                    React.createElement("div", { className: "fontSizeM text-ellipsis" }, props.displayName),
                    signInAddress === "" ? undefined : React.createElement("div", { className: "fontSize secondary-text text-ellipsis" }, signInAddress)),
                isUser(props) && (React.createElement(Button, { className: "bolt-contact-card", iconProps: { iconName: "ContactCard", className: "bolt-contactcard-button flex-shrink" }, onClick: function (e) {
                        _this.openedIdentityCard.value = props;
                        e.stopPropagation();
                    }, subtle: true }))));
        };
        _this.selectedPersonaChanged = function (persona) {
            _this.selectedIdentity.value = persona;
            if (_this.props.onChange && _this.lastPickedIdentity !== persona) {
                !!persona && !!_this.props.pickerProvider.addIdentitiesToMRU && _this.props.pickerProvider.addIdentitiesToMRU([persona]);
                _this.props.onChange(_this.selectedIdentity.value);
            }
            _this.lastPickedIdentity = persona;
        };
        _this.setInputToSelectedPerson = function () {
            var itemValue = _this.suggestionStore.currentSuggestion
                ? _this.suggestionStore.currentSuggestion.item.displayName
                : _this.textValue.value;
            _this.textValue.value = itemValue;
        };
        _this.cachedResults = {};
        _this.suggestionStore = new SuggestionsController();
        _this.timerManagement = new TimerManagement();
        _this.lastPickedIdentity = props.defaultIdentity;
        return _this;
    }
    PeoplePickerDropdown.prototype.render = function () {
        var _this = this;
        return (React.createElement(Observer, { areSuggestionsVisible: this.areSuggestionsVisible, hasFocus: this.hasFocus, openedIdentityCard: this.openedIdentityCard, selectedIdentity: this.selectedIdentity, textValue: this.textValue }, function (props) {
            var _a = _this.props, _b = _a.ariaLabel, ariaLabel = _b === void 0 ? Resources.PeoplePickerPlaceholderText : _b, autoFocus = _a.autoFocus, _c = _a.placeholder, placeholder = _c === void 0 ? Resources.PeoplePickerPlaceholderText : _c;
            var openClassName = (_this.areSuggestionsVisible.value || props.hasFocus) && "bolt-peoplepickerdropdown-open";
            return (React.createElement("div", { className: "bolt-peoplepickerdropdown flex-row flex-grow", ref: _this.outerElement, onClick: _this.onClick, onKeyDown: _this.onKeyDown },
                React.createElement(TextField, { "aria-autocomplete": "none", "aria-label": ariaLabel, "aria-expanded": props.areSuggestionsVisible, "aria-haspopup": "true", autoFocus: autoFocus, className: css(_this.props.className, "bolt-peoplepickerdropdown-textField flex-row flex-center", openClassName), containerClassName: "bolt-peoplepickerdropdown-container flex-column flex-grow", onBlur: _this.onBlur, onChange: _this.onSearchChange, onFocus: _this.onFocus, prefixIconProps: { render: _this.renderPersonaCoin }, placeholder: placeholder, ref: _this.inputElement, role: "comboBox", suffixIconProps: { className: "bolt-dropdown-button", iconName: "ChevronDown" }, value: props.textValue }),
                _this.renderSuggestions(),
                props.openedIdentityCard && (React.createElement(PersonaCard, { getEntityFromUniqueAttribute: _this.props.pickerProvider.getEntityFromUniqueAttribute, key: props.openedIdentityCard.entityId, identity: props.openedIdentityCard, target: _this.outerElement.current, onDismissCallback: _this.closePersonaCard, onRequestConnectionInformation: _this.props.pickerProvider.onRequestConnectionInformation }))));
        }));
    };
    PeoplePickerDropdown.prototype.componentDidMount = function () {
        this.onResolveSuggestions = this.timerManagement.debounce(this.onResolveSuggestions, 250);
        if (this.props.defaultIdentity) {
            this.suggestionStore.updateSuggestions([this.props.defaultIdentity], 0);
            this.selectedIdentity.value = this.props.defaultIdentity;
            this.textValue.value = this.props.defaultIdentity.displayName;
            this.areSuggestionsVisible.value = false;
        }
        else if (this.props.autoFocus) {
            this.updateSuggestionsList(this.props.pickerProvider.onEmptyInputFocus());
        }
    };
    PeoplePickerDropdown.prototype.componentWillUnmount = function () {
        this.currentPromise = undefined;
    };
    PeoplePickerDropdown.prototype.updateSuggestionsList = function (suggestions, initialSearchValue) {
        var _this = this;
        var suggestionsArray = suggestions;
        var suggestionsPromiseLike = suggestions;
        // Check to see if the returned value is an array, if it is then just pass it into the next function.
        // If the returned value is not an array then check to see if it's a promise or PromiseLike. If it is then resolve it asynchronously.
        if (Array.isArray(suggestionsArray)) {
            this.updateSuggestions(suggestionsArray);
        }
        else if (suggestionsPromiseLike && suggestionsPromiseLike.then) {
            if (!this.loadingTimer) {
                this.loadingTimer = this.timerManagement.setTimeout(function () {
                    _this.suggestionsLoading.value = true;
                }, 500);
            }
            // Ensure that the promise will only use the callback if it was the most recent one.
            var promise_1 = (this.currentPromise = suggestionsPromiseLike);
            promise_1.then(function (newSuggestions) {
                if (promise_1 === _this.currentPromise) {
                    _this.suggestionsLoading.value = false;
                    _this.updateSuggestions(newSuggestions, initialSearchValue);
                    if (_this.textValue.value !== "" && _this.suggestionStore.suggestions && _this.suggestionStore.suggestions.length > 0) {
                        _this.cachedResults[_this.textValue.value] = newSuggestions;
                    }
                    if (_this.loadingTimer) {
                        _this.timerManagement.clearTimeout(_this.loadingTimer);
                        _this.loadingTimer = undefined;
                    }
                }
            });
        }
    };
    PeoplePickerDropdown.prototype.renderSuggestions = function () {
        return this.areSuggestionsVisible.value || this.openedIdentityCard.value ? (React.createElement(Callout, { calloutWidth: this.props.calloutWidth, className: "bolt-peoplepickerdropdown-callout", directionalHint: 4 /* bottomLeftEdge */, isBeakVisible: false, onDismiss: this.hidePicker, target: this.outerElement.current },
            React.createElement(Suggestions, { className: "bolt-peoplepickerdropdown-list", isLoading: this.suggestionsLoading.value, isResultsFooterVisible: this.props.isResultsFooterVisible, loadingText: Resources.PeoplePickerLoadingText, onRenderNoResultFound: this.renderNoIdentitiesFound, onRenderSuggestion: this.renderSuggestionItem, onSuggestionClick: this.onSuggestionClick, ref: this.suggestionsControl, resultsMaximumNumber: this.props.resultsMaximumNumber, suggestionsContainerAriaLabel: this.props.suggestionsContainerAriaLabel, suggestionsItemClassName: css("bolt-peoplepickerdropdown-item", this.props.suggestionsItemClassName), suggestions: this.suggestionStore.getSuggestions() }))) : null;
    };
    PeoplePickerDropdown.prototype.updateSuggestions = function (suggestions, initialSearchValue) {
        // Only update the suggestions if the initial search value is the same as the current input
        if (initialSearchValue === undefined || (this.inputElement.current && this.textValue.value === initialSearchValue)) {
            this.suggestionStore.updateSuggestions(suggestions, 0);
            if (initialSearchValue !== undefined) {
                this.selectedIdentity.value = undefined;
            }
            this.forceUpdate();
        }
    };
    PeoplePickerDropdown.prototype.updateValue = function (updatedValue) {
        if (this.cachedResults[updatedValue]) {
            this.updateSuggestionsList(this.cachedResults[updatedValue], updatedValue);
        }
        else {
            this.onResolveSuggestions(updatedValue);
        }
    };
    PeoplePickerDropdown.defaultProps = {
        calloutWidth: 296
    };
    return PeoplePickerDropdown;
}(React.Component));
export { PeoplePickerDropdown };
