import "../../FabricInit";
import { IPoint } from "office-ui-fabric-react/lib/Utilities";
import { IIdentity, IPersonaConnections } from "../PeoplePicker/SharedPeoplePicker.Props";
export declare enum CardType {
    Default = 0,
    Contact = 1,
    Organization = 2
}
export interface IDataState {
    header?: IIdentity;
    identity: IIdentity;
    managerList?: IIdentity[];
    directReportList?: IIdentity[];
    previousDataState?: IDataState;
    cardType?: CardType;
    displayName?: string;
    imageUrl?: string;
    email?: string;
    source?: string;
}
export interface PersonaCardProps {
    identity?: IIdentity;
    consumerId?: string;
    uniqueAttribute?: string;
    initialHeader?: HeaderElementProps;
    displayName?: string;
    imageUrl?: string;
    referenceHTMLComponent?: HTMLElement;
    target?: HTMLElement | IPoint;
    onDismissCallback?: () => void;
    /**
     * Request connection information about a given Entity.
     */
    onRequestConnectionInformation: (entity: IIdentity, getDirectReports?: boolean) => IPersonaConnections | PromiseLike<IPersonaConnections>;
    /**
     * Request Entity information about a given Entity.
     */
    getEntityFromUniqueAttribute: (entityId: string) => IIdentity | PromiseLike<IIdentity>;
}
export interface PersonaCardContentProps extends PersonaCardProps {
    dataProps: IDataState;
    onClickEntity?: (identity: IIdentity) => void;
    onHeaderClick?: () => void;
    onShowOrganizationCard?: () => void;
    onShowContactCard: () => void;
    working?: boolean;
}
/**
 * Definitions for HeaderElement used by PersonaCard.
 */
export interface HeaderElementProps {
    /**
     * Current data state (can be null).
     */
    identity?: IIdentity;
    /**
     * Function on click (show default card or pop breadcrumb).
     */
    onClickFunction?: () => void;
    /**
     * Function to set the focus to first active element of focuszone on update of the card.
     */
    setFocus?: () => void;
}
