import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./PersonaCard.css";
/**
 * The PersonaCard is intended to show contact and organization information for an identity.
 * You may pass the entity directly or you may pass a unique attribute (e.g. uniqueName, entityID, signInAddress) as a prop.
 *
 */
import * as React from "react";
import { IDataState, PersonaCardProps } from "./PersonaCard.Props";
export interface PersonaCardState {
    /** Mimics stack to allow for breadcrumb */
    dataState: IDataState;
    /** Prevent requests if working */
    working: boolean;
}
export declare class PersonaCard extends React.Component<PersonaCardProps, PersonaCardState> {
    private _dismissed;
    constructor(props: PersonaCardProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private _onDismissCallback;
    private _headerOnClickHandler;
    private _onShowContactCard;
    private _onShowOrganizationCard;
    private _onClickEntity;
    private _setupInitialData;
    private _resolveIdentity;
    private _resolveIEntity;
    private _updateConnections;
    private _updateEntity;
    private _getIdentityByUniqueAttribute;
    private _getEmail;
}
