import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./PersonaCard.css";
import * as React from "react";
import * as Resources from '../../VSS.Resources.VSSUI';
import { VssIcon, VssIconType } from '../../VssIcon';
import { VssPersona } from '../../VssPersona';
var PersonaCardHeaderElement = /** @class */ (function (_super) {
    tslib_1.__extends(PersonaCardHeaderElement, _super);
    function PersonaCardHeaderElement() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PersonaCardHeaderElement.prototype.componentDidMount = function () {
        this.props.setFocus && this.props.setFocus();
    };
    PersonaCardHeaderElement.prototype.componentDidUpdate = function () {
        this.props.setFocus && this.props.setFocus();
    };
    // Render
    PersonaCardHeaderElement.prototype.render = function () {
        var _this = this;
        if (!this.props.identity) {
            // Identity is null in the case of previous
            return null;
        }
        var identity = this.props.identity;
        var personaData = {
            imageUrl: identity.image,
            primaryText: identity.displayName,
            secondaryText: identity.jobTitle,
            tertiaryText: identity.department
        };
        return (React.createElement("div", { className: "go-back-persona-wrapper", onClick: this.props.onClickFunction, "aria-label": Resources.PeoplePickerHeaderButtonLabel, ref: function (element) {
                _this._personaElement = element;
            }, "data-is-focusable": true, role: "button" },
            React.createElement("div", null,
                React.createElement(VssIcon, { iconType: VssIconType.fabric, iconName: "ChevronLeft" })),
            React.createElement("div", { className: "go-back-positioning flex-row" },
                React.createElement(VssPersona, { displayName: personaData.primaryText, imageUrl: personaData.imageUrl, className: "go-back-persona", size: "small", suppressPersonaCard: true }),
                React.createElement("div", { className: "flex-column flex-grow persona-card-name" },
                    React.createElement("div", { className: "persona-header-text-primary" }, personaData.primaryText)))));
    };
    /**
     * Sets the focus on this header.
     */
    PersonaCardHeaderElement.prototype.setFocus = function () {
        if (this._personaElement) {
            this._personaElement.focus();
        }
    };
    return PersonaCardHeaderElement;
}(React.Component));
export { PersonaCardHeaderElement };
