import * as tslib_1 from "tslib";
import "../../FabricInit";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./PickList.css";
import "./PickListDropdown.css";
import * as React from "react";
import { BaseComponent } from "office-ui-fabric-react/lib/Utilities";
import { css } from '../../Util';
import { PickList } from "./PickList";
import { PickListDropdown } from "./PickListDropdown";
export var PICKER_CHANGE_EVENT = "picker-changed";
var ItemPickerComponentBase = /** @class */ (function (_super) {
    tslib_1.__extends(ItemPickerComponentBase, _super);
    function ItemPickerComponentBase(props) {
        var _this = _super.call(this, props) || this;
        _this.updateDelegate = function () { return _this.forceUpdate(); };
        _this.state = {};
        return _this;
    }
    ItemPickerComponentBase.prototype.componentDidMount = function () {
        this._events.on(this.props.provider, PICKER_CHANGE_EVENT, this.updateDelegate);
    };
    ItemPickerComponentBase.prototype.componentWillUnmount = function () {
        this._events.off(this.props.provider, PICKER_CHANGE_EVENT, this.updateDelegate);
    };
    ItemPickerComponentBase.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.provider !== nextProps.provider) {
            this._events.off(this.props.provider, PICKER_CHANGE_EVENT, this.updateDelegate);
            this._events.on(nextProps.provider, PICKER_CHANGE_EVENT, this.updateDelegate);
        }
    };
    return ItemPickerComponentBase;
}(BaseComponent));
export { ItemPickerComponentBase };
var ItemPickerDropdown = /** @class */ (function (_super) {
    tslib_1.__extends(ItemPickerDropdown, _super);
    function ItemPickerDropdown() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ItemPickerDropdown.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, provider = _a.provider, minWidth = _a.minWidth, pickListWidth = _a.pickListWidth, pickListClassName = _a.pickListClassName, tabIndex = _a.tabIndex, placeholderText = _a.placeholderText, hideSelectedItemIcon = _a.hideSelectedItemIcon, dropdownIconProps = _a.dropdownIconProps, autoFocus = _a.autoFocus, onFocus = _a.onFocus, onFocusLost = _a.onFocusLost;
        return (React.createElement(PickListDropdown, { id: this.props.id, componentRef: function (pickListDropdown) { return (_this.pickListDropdown = pickListDropdown); }, className: css("item-picker-dropdown", className), getListItem: provider.getListItem, getPickListItems: function () {
                return provider.getItems();
            }, onSelectionChanged: function (selection) {
                return provider.onSelectedItemChanged
                    ? provider.onSelectedItemChanged(selection && selection.selectedItems ? selection.selectedItems[0] : undefined)
                    : false;
            }, selectedItems: provider.selectedItem ? [provider.selectedItem] : undefined, indicators: provider.dropdownIndicators, pickListClassName: pickListClassName, selectedItemIndicators: provider.selectedItemIndicators, pivots: provider.pivots, groups: provider.groups, limitSearchToPivot: provider.limitSearchToPivot, onGroupLoadRequest: provider.onGroupLoadRequest, placeholder: placeholderText, isSearchable: provider.isSearchable, minItemsForSearchBox: provider.minItemsForSearchBox, searchTextPlaceholder: provider.searchTextPlaceholder, searchResultsGroupName: provider.searchResultsGroupName, searchResultsLoadingText: provider.searchResultsLoadingText, searchNoResultsText: provider.searchNoResultsText, onSearch: provider.onSearch, onHasMoreSearchResults: provider.onHasMoreSearchResults, onFilterItemByText: provider.onFilterItemByText, getActions: function (items) { return provider.actions; }, noItemsText: provider.noItemsText, selectExactMatchOnEnter: provider.selectExactMatchOnEnter, width: minWidth, pickListWidth: pickListWidth, tabIndex: tabIndex, hideSelectedItemIcon: hideSelectedItemIcon, dropdownIconProps: dropdownIconProps, autoFocus: autoFocus, shouldVirtualize: function (items) {
                return (items || []).length > 50;
            }, onRenderItemText: this.props.onRenderItemText, isOpen: this.props.isOpen, onToggleDropdown: this.props.onToggleDropdown, ariaDescribedBy: this.props.ariaDescribedBy, onFocus: onFocus, onFocusLost: onFocusLost }));
    };
    ItemPickerDropdown.prototype.focus = function () {
        if (this.pickListDropdown) {
            this.pickListDropdown.focus();
        }
    };
    return ItemPickerDropdown;
}(ItemPickerComponentBase));
export { ItemPickerDropdown };
var ItemPickList = /** @class */ (function (_super) {
    tslib_1.__extends(ItemPickList, _super);
    function ItemPickList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ItemPickList.prototype.render = function () {
        var _this = this;
        var _a = this.props, className = _a.className, provider = _a.provider, useDropdownStyle = _a.useDropdownStyle, shouldVirtualize = _a.shouldVirtualize;
        return (React.createElement(PickList, { componentRef: function (pickList) { return (_this.pickList = pickList); }, className: css(useDropdownStyle ? "item-picker-dropdown" : "item-picker-list", className), getListItem: provider.getListItem, items: provider.getItems(), onSelectionChanged: function (selection) {
                return provider.onSelectedItemChanged
                    ? provider.onSelectedItemChanged(selection && selection.selectedItems ? selection.selectedItems[0] : undefined)
                    : false;
            }, selectedItems: provider.selectedItem ? [provider.selectedItem] : undefined, indicators: provider.dropdownIndicators, groups: provider.groups, pivots: provider.pivots, limitSearchToPivot: provider.limitSearchToPivot, onGroupLoadRequest: provider.onGroupLoadRequest, isSearchable: provider.isSearchable, searchTextPlaceholder: provider.searchTextPlaceholder, searchResultsGroupName: provider.searchResultsGroupName, searchResultsLoadingText: provider.searchResultsLoadingText, searchNoResultsText: provider.searchNoResultsText, onSearch: provider.onSearch, onHasMoreSearchResults: provider.onHasMoreSearchResults, onFilterItemByText: provider.onFilterItemByText, getActions: function (items) { return provider.actions; }, noItemsText: provider.noItemsText, selectExactMatchOnEnter: provider.selectExactMatchOnEnter, shouldVirtualize: shouldVirtualize
                ? shouldVirtualize
                : function (items) {
                    return (items || []).length > 50;
                }, minItemsForSearchBox: useDropdownStyle ? undefined : 1, onRenderItemText: this.props.onRenderItemText }));
    };
    return ItemPickList;
}(ItemPickerComponentBase));
export { ItemPickList };
