import { IResponsiveLayoutProps } from '../../ResponsiveLayout';
import { IMenuItem } from "../Menu/Menu.Props";
import { ObservableArray } from '../../Core/Observable';
/**
 * IResizeGroupContext is available through the ResizeGroup Consumer.
 */
export interface IResizeGroupContext {
    overflowItems?: ObservableArray<IMenuItem>;
}

/**
 * Set of properties used to create a ResizeGroup component.
 */
export interface IResizeGroupProps {
    /**
     * Props to forward to the responsive layout.
     */
    responsiveLayoutProps: IResponsiveLayoutProps;

    /**
     * An array of menu items that correspond to responsiveChildren. Hidden responsive items
     * will have their corresponding menu items forwarded to ResizeGroupContext Consumers.
     */
    overflowMenuItems: IMenuItem[];
}