export declare enum SpinnerSize {
    /**
     * 12px diameter
     */
    xSmall = "xsmall",
    /**
     * 16px diameter
     */
    small = "small",
    /**
     * 20px diameter
     */
    medium = "medium",
    /**
     * 28px diameter
     */
    large = "large"
}
export interface ISpinnerProps {
    /**
     * Optional aria-live value
     * @default polite
     */
    ariaLive?: "off" | "assertive" | "polite";
    /**
     * Optional aria-label
     */
    ariaLabel?: string;
    /**
     * Optional custom classname
     */
    className?: string;
    /**
     * Optional label text
     */
    label?: string;
    /**
     * Optional spinner size
     * @default SpinnerSize.medium
     */
    size?: SpinnerSize;
}
