/// <reference types="react" />
export interface IStatusProps {
    /**
     * Used to identify the fill color for the Status svg.
     */
    color: string;
    /**
     * Animate the icon (if supported). Defaults to true for Running.
     */
    animated?: boolean;
    /**
     * Renders an icon of the provided size with the provided className
     */
    onRenderIcon: (className: string, size: StatusSize, animated?: boolean) => JSX.Element;
    /**
     * Optional classname to add to the Status component.
     */
    className?: string;
    /**
     * Size of the component
     */
    size?: StatusSize;
    /**
     * If provided, will turn the component into an extended status pill
     * with this text
     */
    text?: string;
}
export declare enum StatusSize {
    s = "12",
    m = "16",
    l = "24",
    xl = "32"
}
