export declare enum SurfaceBackground {
    normal = 0,
    neutral = 1,
    callout = 2
}
export interface ISurfaceContext {
    /**
     * Specifies the background color of the surface onto which a component will be
     * rendered. This allows components which consume the context to decide if anything
     * about their rendering needs to be changed.
     *
     * @default normal
     */
    background: SurfaceBackground;
}
export interface ISurfaceProps {
    /**
     * Specifies the semantic background color of the surface.
     */
    background: SurfaceBackground;
}
