import * as tslib_1 from "tslib";
import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./TeachingPanel.css";
import * as React from "react";
import { Callout, ContentJustification, ContentLocation, ContentOrientation } from '../../Callout';
import { FocusZone } from '../../FocusZone';
import { Button } from '../../Button';
import { css } from '../../Util';
import * as Resources from '../../Resources.TeachingPanel';
var TeachingPanel = /** @class */ (function (_super) {
    tslib_1.__extends(TeachingPanel, _super);
    function TeachingPanel(props) {
        var _this = _super.call(this, props) || this;
        _this.nextButton = React.createRef();
        _this._onPanelClose = function () {
            _this.setState({ shouldShow: false });
            _this.props.onDismiss && _this.props.onDismiss(_this.state.slideIndex);
        };
        _this._onNextPressed = function () {
            if (_this.state.slideIndex + 1 === _this.props.slides.length) {
                _this._onPanelClose();
            }
            else {
                _this.setState({ slideIndex: _this.state.slideIndex + 1 });
            }
        };
        _this._onBackPressed = function () {
            if (_this.state.slideIndex > 0) {
                // If we are on the second slide before moveing to the first slide, set
                // focus to the next button, otherwise focus is lost.
                if (_this.state.slideIndex === 1 && _this.nextButton.current) {
                    _this.nextButton.current.focus();
                }
                _this.setState({ slideIndex: _this.state.slideIndex - 1 });
            }
        };
        _this._renderProgress = function (currentIndex) {
            return (React.createElement("div", { className: "bolt-teaching-panel-progress flex-row flex-grow" },
                React.createElement("div", { className: "flex-grow" }),
                React.createElement("div", { className: "bolt-teaching-panel-progress-group flex-row flex-shrink" }, _this.props.slides.map(function (item, index) {
                    return (React.createElement("div", { key: "progress-" + index, className: css("bolt-teaching-panel-progress-circle", currentIndex === index && "current") }));
                })),
                React.createElement("div", { className: "flex-grow" })));
        };
        _this._renderPanel = function () {
            var currentSlide = _this.props.slides[_this.state.slideIndex];
            var firstSlide = _this.state.slideIndex === 0;
            var lastSlide = _this.state.slideIndex + 1 === _this.props.slides.length;
            if (!currentSlide) {
                return null;
            }
            return (React.createElement(Callout, { className: "bolt-teaching-panel-layer", contentClassName: "bolt-teaching-panel", contentJustification: ContentJustification.Center, contentLocation: ContentLocation.Center, contentOrientation: ContentOrientation.Column, contentShadow: true, escDismiss: true, lightDismiss: true, modal: true, onDismiss: _this._onPanelClose },
                React.createElement(FocusZone, { circularNavigation: true, defaultActiveElement: ".bolt-teaching-panel-next", focusOnMount: true, handleTabKey: true },
                    React.createElement("div", { className: "bolt-teaching-panel-wrapper-div flex-grow flex-column scroll-hidden" },
                        React.createElement("div", { className: "bolt-teaching-panel-image-div flex-row" },
                            React.createElement("img", { className: "bolt-teaching-panel-image flex-row", src: currentSlide.slideImage, alt: currentSlide.imageAltText }),
                            React.createElement(Button, { subtle: true, className: "bolt-teaching-pane-close-button", ariaLabel: Resources.Close, iconProps: { iconName: "Cancel" }, onClick: _this._onPanelClose })),
                        React.createElement("div", { className: "bolt-teaching-panel-text-div flex-column" },
                            React.createElement("div", { className: "bolt-teaching-panel-header flex-shrink title-m" }, currentSlide.title),
                            React.createElement("div", { className: "bolt-teaching-panel-text flex-grow body-l", dangerouslySetInnerHTML: { __html: currentSlide.description } }),
                            React.createElement("div", { className: "flex-row flex-shrink body-m" },
                                React.createElement("div", { className: "bolt-teach-panel-button-container flex-grow" },
                                    React.createElement(Button, { text: Resources.Back, onClick: _this._onBackPressed, className: css("bolt-teaching-panel-back flex-shrink", firstSlide && "first-slide"), disabled: _this.state.slideIndex <= 0 })),
                                _this._renderProgress(_this.state.slideIndex),
                                React.createElement("div", { className: "bolt-teach-panel-button-container flex-grow" },
                                    React.createElement(Button, { ref: _this.nextButton, primary: true, text: lastSlide ? Resources.Done : Resources.Next, onClick: _this._onNextPressed, className: "bolt-teaching-panel-next flex-shrink" }))))))));
        };
        _this.state = {
            slideIndex: 0,
            shouldShow: true
        };
        return _this;
    }
    TeachingPanel.prototype.render = function () {
        return this.state.shouldShow ? this._renderPanel() : null;
    };
    return TeachingPanel;
}(React.Component));
export { TeachingPanel };
