import { IFilterBarItemProps } from '../../FilterBarItem';
/**
 * Properties for a text-box filter bar item component
 */
export interface ITextFilterBarProps extends IFilterBarItemProps {
    /**
     * Optional className to use for the FilterBarItem
     */
    className?: string;
    /**
     * Optional className to use for the TextFilterBarItem's input element
     */
    inputClassName?: string;
    /**
     * Placeholder text for the TextField
     */
    placeholder?: string;
    /**
     * The maxLength property to be passed to the input in the TextField.
     * Default value is 200 characters.
     */
    maxTextLength?: number;

    /**
     * The throttle wait time to use when updating the filter. The text field
     * will still update on every keystroke, but the updating the filter
     * itself will be throttled by this amount. The default value is 200 ms.
     * Passing a value of 0 here will cause this text field not to be throttled.
     */
    throttleWait?: number;
}