import "../../CommonImports";
import "../../Core/core.css";
import "../../Common.css";
import "./Tooltip.css";
import * as React from "react";
import { ITooltipProps } from "./Tooltip.Props";
import { IPoint, IOffset, IOrigin } from '../../Utilities/Position';
export interface ITooltipState {
    anchorElement?: HTMLElement;
    anchorOffset?: IOffset;
    anchorOrigin?: IOrigin;
    anchorPoint?: IPoint;
    focus: boolean;
    innerText?: string;
    mouse: boolean;
    tooltipOrigin?: IOrigin;
}
export declare class Tooltip extends React.Component<ITooltipProps, ITooltipState> {
    private openTimeout;
    private existingBlur?;
    private existingFocus?;
    private existingMouseEnter?;
    private existingMouseLeave?;
    static defaultProps: {
        delayMs: number;
    };
    constructor(props: Readonly<ITooltipProps>);
    render(): JSX.Element;
    componentWillUnmount(): void;
    private onBlur;
    private onFocus;
    private onMouseEnter;
    private onMouseLeave;
}
