export interface IItemProvider<TItem> {
    loadItems(itemsUpdated: (items: TItem[]) => void): void;
}

export interface IItemWithIdProvider<TItem> {
    loadItems(itemsUpdated: (items: TItem[]) => void, itemsRemoved?: string[]): void;
}

export interface IItemArrayProvider<TItem> {
    loadItems(items: ObservableArray<TItem>): void;
    loadItemsAsync(items: ObservableArray<TItem>): void;
}